@import "../../../../styles/colors";

$popup-timer: 0.3s;
$hover-timer: 0.1s;

.popup-item {
  position: relative;
  background-color: $color-white;
  border-bottom: 1px solid $color-botticelli;
  cursor: pointer;
  min-height: 70px;
  box-sizing: border-box;
  display: flex;
  flex-direction: column;
  justify-content: center;
  overflow: hidden;

  &__one-secret {
    border-top: 1px solid $color-botticelli;
  }

  &__name {
    position: relative;
    padding: 0 10px;
    font-weight: bold;
    line-height: 18px;
    font-size: 16px;
    letter-spacing: -0.01em;
    color: $color-thunder;
    width: calc(100% - 110px);
    max-height: 36px;
    overflow: hidden;
    margin-top: 3px;
    z-index: 1;
  }

  &__subtitle {
    width: calc(100% - 110px);
    height: 18px;
    margin-right: 0;
    padding: 0 10px;
    font-size: 12px;
    line-height: 18px;
    color: $color-thunder;
    white-space: nowrap;
    overflow: hidden;
    z-index: 1;

    &__item {
      transform: translateY(0);
      transition: transform 0.3s ease-in-out 0.75s;
    }
  }

  &__icon {
    display: inline-block;
    width: 24px;
    height: 24px;
    margin-right: 0;
    fill: $color-gothic;
    transform: scale(1);
    transform-origin: bottom center;
    vertical-align: -7px;
    transition: color $hover-timer, transform $popup-timer;
    pointer-events: auto;
  }

  &__caret {
    position: absolute;
    top: calc(50% - 10px);
    right: 10px;
    opacity: 1;
    width: 0.833333em;
    height: 0.833333em;
    color: $color-gothic;
    font-size: 20px;
    font-weight: 700;
    line-height: 1.08333em;
    transform: rotate(315deg) scale(1);
    transition: color $hover-timer, transform $hover-timer, opacity $popup-timer;

    &:hover {
      color: $color-deep-cerulean;
      transform: rotate(315deg) scale(1.2);
    }
  }

  &__actions {
    position: absolute;
    display: flex;
    flex-wrap: wrap;
    justify-content: flex-end;
    top: 50px;
    width: 345px;
    font-size: 0;
    pointer-events: none;
    transform: translate(10px, -27px);
    transition: transform $popup-timer;

    // This is a little hack to get the items beyond the top row to expand the way we want.
    // Also note the order attached to the :nth-child(n+3) block below.
    &:before {
      content: "";
      width: 100%;
      order: 1;
    }

    &:not(.popup-item__actions--matched) {
      .popup-item__action:nth-child(1) {
        .popup-item__icon {
          transform: translateX(105px) scale(1);

          &:hover {
            transform: translateX(105px) scale(1.1);
          }
        }
      }
      .popup-item__action:nth-child(2) {
        .popup-item__icon {
          transform: translateX(-25px) scale(1);

          &:hover {
            transform: translateX(-25px) scale(1.1);
          }
        }
      }
    }

    &--matched {
      .popup-item__action {
        &:nth-child(n + 2) {
          opacity: 0;
          order: 2;
        }

        &:nth-child(1) {
          .popup-item__icon {
            transform: translateX(-25px) scale(1);

            &:hover {
              transform: translateX(-25px) scale(1.1);
            }
          }
        }
      }

      .popup-item--active & {
        .popup-item__action {
          &:nth-child(n + 2) {
            opacity: 1;
          }
        }
      }
    }
  }

  &__action {
    display: inline-block;
    position: relative;
    width: 50%;
    height: 32px;
    margin: 0 0 5px;
    transform: scale(1);
    transform-origin: center right;

    &:hover {
      .popup-item__action-text {
        color: $color-deep-cerulean;
        transform: scale(1.05);
      }

      .popup-item__icon {
        fill: $color-deep-cerulean;
        transform: translateX(0) scale(1.2);
      }
    }

    &:nth-child(n + 3) {
      opacity: 0;
      order: 2;
    }

    &:nth-child(2n + 1) {
      .popup-item__action-inner {
        // transform: translateX(660px);
        transition: none;
      }
    }

    &--disabled {
      color: $color-botticelli;

      .popup-item__icon {
        fill: $color-botticelli !important;
      }

      &:hover {
        .popup-item__action-text {
          color: $color-botticelli;
          transform: scale(1);
        }

        .popup-item__icon {
          fill: $color-botticelli;
          transform: translateX(105px) scale(1) !important;
        }
      }
    }

    &--copied {
      .popup-item__action-text {
        color: $color-de-york !important;
      }

      .popup-item__icon {
        fill: $color-de-york !important;
      }
    }
  }

  &__action-text {
    display: inline-block;
    width: 119px;
    padding-right: 10px;
    font-size: 14px;
    line-height: 20px;
    white-space: nowrap;
    opacity: 0;
    transition: opacity $hover-timer, transform $hover-timer;
  }

  &:not(.popup-item--active):hover {
    .popup-item__caret {
      color: $color-deep-cerulean;
      transform: rotate(315deg) scale(1.2);
    }

    .popup-item__subtitle__item {
      transform: translateY(-18px);
    }
  }

  &__actions:hover + .popup-item__caret {
    color: $color-gothic !important;
    transform: rotate(315deg) scale(1) !important;
  }

  &--active {
    .popup-item {
      &__name {
        width: 100%;
        margin-top: 15px;
      }

      &__subtitle {
        width: 100%;
      }

      &__icon {
        fill: $color-thunder;
        transform: scale(1);
        transition: color $hover-timer, transform $popup-timer;
      }

      &__caret {
        opacity: 0;
      }

      &__action {
        transform: scale(1);
        transition: transform $popup-timer linear;
        &:nth-child(n + 3) {
          opacity: 1;
        }

        &:nth-child(2n + 1) {
          .popup-item__action-inner {
            transform: translateX(0);
            transition: transform $popup-timer;
          }
        }

        &:hover {
          .popup-item__icon {
            transform: scale(1.1);
          }
        }

        &--matched {
          font-weight: 600;

          .popup-item__action-inner {
            transform: translateX(-100%) !important;
          }
          .popup-item__action-text {
            color: $color-deep-cerulean;
          }
          .popup-item__icon {
            fill: $color-deep-cerulean;
          }
        }

        &--disabled {
          &:hover {
            .popup-item__icon {
              transform: translateX(0) scale(1) !important;
            }
          }
        }
      }

      &__actions {
        position: relative;
        top: 0;
        width: 100%;
        margin-bottom: 10px;
        pointer-events: auto;
        transform: translate(10px, 10px);

        &:not(.popup-item__actions--matched) {
          .popup-item__action:nth-child(-n + 2) {
            .popup-item__icon {
              transform: translateX(0) scale(1);
            }

            &:hover .popup-item__icon {
              transform: translateX(0) scale(1.1);
            }
          }
        }

        &--matched {
          .popup-item__action:nth-child(1) {
            .popup-item__icon {
              transform: translateX(0) scale(1);
            }

            &:hover .popup-item__icon {
              transform: translateX(0) scale(1.1);
            }
          }
        }
      }

      &__action-text {
        opacity: 1;
      }
    }
  }
}
